commit bdd543db33706643993a468740487147c89a4bd2
Author: Jakub Jelinek <jakub@redhat.com>
Date:   Fri Mar 17 16:10:14 2023 +0100

    c, ubsan: Instrument even shortened divisions [PR109151]
    
    On the following testcase, the C FE decides to shorten the division because
    it has a guarantee that INT_MIN / -1 division won't be encountered, the
    first operand is widened from narrower unsigned and/or the second operand is
    a constant other than all ones (in this case both are true).
    The problem is that the narrower type in this case is _Bool and
    ubsan_instrument_division only instruments it if op0's type is INTEGER_TYPE
    or REAL_TYPE.  Strangely this doesn't happen in C++ FE.
    Anyway, we only shorten divisions if the INT_MIN / -1 case is impossible,
    so I think we should be fine even with -fstrict-enums in C++ in case it
    shortened to ENUMERAL_TYPEs.
    
    The following patch just instruments those on the ubsan_instrument_division
    side.  Perhaps only the first hunk and testcase might be needed because
    we shouldn't shorten if the other case could be triggered.
    
    2023-03-17  Jakub Jelinek  <jakub@redhat.com>
    
            PR c/109151
            * c-ubsan.c (ubsan_instrument_division): Handle all scalar integral
            types rather than just INTEGER_TYPE.
    
            * c-c++-common/ubsan/div-by-zero-8.c: New test.
    
    (cherry picked from commit 103d423f6ce72ccb03d55b7b1dfa2dabd5854371)

diff --git a/gcc/c-family/c-ubsan.c b/gcc/c-family/c-ubsan.c
index 1997e8b5bd1..63e6f11fba2 100644
--- a/gcc/c-family/c-ubsan.c
+++ b/gcc/c-family/c-ubsan.c
@@ -53,7 +53,7 @@ ubsan_instrument_division (location_t loc, tree op0, tree op1)
   op0 = unshare_expr (op0);
   op1 = unshare_expr (op1);
 
-  if (TREE_CODE (type) == INTEGER_TYPE
+  if (INTEGRAL_TYPE_P (type)
       && sanitize_flags_p (SANITIZE_DIVIDE))
     t = fold_build2 (EQ_EXPR, boolean_type_node,
 		     op1, build_int_cst (type, 0));
@@ -68,7 +68,7 @@ ubsan_instrument_division (location_t loc, tree op0, tree op1)
     return NULL_TREE;
 
   /* We check INT_MIN / -1 only for signed types.  */
-  if (TREE_CODE (type) == INTEGER_TYPE
+  if (INTEGRAL_TYPE_P (type)
       && sanitize_flags_p (SANITIZE_DIVIDE)
       && !TYPE_UNSIGNED (type))
     {
diff --git a/gcc/testsuite/c-c++-common/ubsan/div-by-zero-8.c b/gcc/testsuite/c-c++-common/ubsan/div-by-zero-8.c
new file mode 100644
index 00000000000..02e1d7cfc95
--- /dev/null
+++ b/gcc/testsuite/c-c++-common/ubsan/div-by-zero-8.c
@@ -0,0 +1,14 @@
+/* PR c/109151 */
+/* { dg-do run } */
+/* { dg-options "-fsanitize=integer-divide-by-zero -Wno-div-by-zero -fno-sanitize-recover=integer-divide-by-zero" } */
+/* { dg-shouldfail "ubsan" } */
+
+int d;
+
+int
+main ()
+{
+  d = ((short) (d == 1 | d > 9)) / 0;
+}
+
+/* { dg-output "division by zero" } */

